<template>
  <div>
    <div class="columns top">
      <div class="column col-12">
        <data-tables-server
          :data="payroll"
          :total="payroll.length"
          @query-change="getPayRegister"
          :pagination-props="pagination"
          :table-props="tableProps"
          :layout="layout"
        >
          <el-table-column type="selection" width="55"></el-table-column>
          <el-table-column label="Name" sortable="custom">
            <template slot-scope="scope">
              <span type="text" class="td_text">{{ scope.row.employee_name }}</span>
            </template>
          </el-table-column>
          <el-table-column label="Gross Pay" sortable="custom">
            <template slot-scope="scope">
              <span>{{ formatNumber(scope.row.earnings) }}</span>
            </template>
          </el-table-column>
          <el-table-column label="Deductions">
            <template slot-scope="scope">
              <span>{{ formatNumber(scope.row.deductions) }}</span>
            </template>
          </el-table-column>
          <el-table-column label="Net Pay">
            <template slot-scope="scope">
              <span>{{ formatNumber(scope.row.net_pay) }}</span>
            </template>
          </el-table-column>
        </data-tables-server>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "payregister",
  props: ["payslip_data"],
  data() {
    return {
      ledger: this.payslip_data,
      payroll: [],
      total: null,
      pagination: { pageSizes: [25, 50, 100] },
      tableProps: {
        border: false,
        stripe: true,
        defaultSort: {
          prop: "flow_no",
          order: "descending"
        }
      },
      layout: "pagination, table",
      emp_id: []
    };
  },
  mounted() {
    // this.getIds()
    
    // this.getPayRegister();
  },
  methods: {
    getPayRegister() {
      this.payroll = this.ledger
    },
    formatNumber(number, signed = false) {
      let result = new Intl.NumberFormat().format(number);
      return signed ? `- ₦ ${result}` : `₦ ${result}`;
    },
    getName() {
      for (var i = 0; i < this.emp_id.length; i++) {
        axios.get("/api/employees/" + this.emp_id[i]).then(response => {
            this.names.push(response.data.first_name + " " + response.data.surname) 
        })
      }
    },
    getIds() {
      var ids = [];
      for (let i = 0; i < this.ledger.length; i++) {
        ids.push(this.ledger[i].employee_id);
      }
      this.emp_id = Array.from(new Set(ids));
    }
  }
}
</script>

<style scoped>
.top {
  margin-top: 30px;
}
</style>